//--------------------------------------------------------
//  Zelda Classic
//  by Jeremy Craner, 1999-2000
//
//  defdata.cc
//
//  Default item, weapon, and enemy data for Zelda Classic.
//
//  This data was originally hard coded in the item class,
//  enemy classes, etc. I exctracted it to make generic
//  classes, thus allowing custom items and enemies.
//
//--------------------------------------------------------

#include "precompiled.h" //always first

#include "defdata.h"
#include "sfx.h"

/*

  combo_class_buf[combo_type].variable

  combo types left to do:

  cNONE, cSTAIR, cCAVE, cARMOS, cGRAVE,
  cUNDEF, cPUSH_WAIT, cPUSH_HEAVY, cPUSH_HW, cL_STATUE, cR_STATUE,
  cSWIMWARP, cDIVEWARP,
  cLADDERHOOKSHOT, cTRIGNOFLAG, cTRIGFLAG, cZELDA, cSLASH, cSLASHITEM,
  cPUSH_HEAVY2, cPUSH_HW2, cPOUND, cHSGRAB, cHSBRIDGE, cC_STATUE, cTRAP_H, cTRAP_V, cTRAP_4,
  cTRAP_LR, cTRAP_UD, cPIT, cHOOKSHOTONLY, cNOFLYZONE, cMIRROR,
  cMIRRORSLASH, cMIRRORBACKSLASH, cMAGICPRISM, cMAGICPRISM4,
  cCAVE2, cNOJUMPZONE, cBUSH,
  cFLOWERS, cTALLGRASS, cSHALLOWWATER, cLOCKBLOCK, cLOCKBLOCK2,
  cBOSSLOCKBLOCK, cBOSSLOCKBLOCK2, cLADDERONLY, cBSGRAVE,
  cCHEST, cCHEST2, cLOCKEDCHEST, cLOCKEDCHEST2, cBOSSCHEST, cBOSSCHEST2,
  cRESET, cSAVE, cSAVE2, cCAVEB, cCAVEC, cCAVED,
  cSTAIRB, cSTAIRC, cSTAIRD, cPITB, cPITC, cPITD,
  cCAVE2B, cCAVE2C, cCAVE2D, cSWIMWARPB, cSWIMWARPC, cSWIMWARPD,
  cDIVEWARPB, cDIVEWARPC, cDIVEWARPD, cSTAIRR, cPITR,
  cAWARPA, cAWARPB, cAWARPC, cAWARPD, cAWARPR,
  cSWARPA, cSWARPB, cSWARPC, cSWARPD, cSWARPR, cSTRIGNOFLAG, cSTRIGFLAG,
  cSTEP, cSTEPSAME, cSTEPALL, cSTEPCOPY, cNOENEMY,
  cCHANGE, cSPINTILE1, cSPINTILE2,
  cSCREENFREEZE, cSCREENFREEZEFF, cICE, cSLASHNEXT, cSLASHNEXTITEM, cBUSHNEXT,
  cSLASHTOUCHY, cSLASHITEMTOUCHY, cBUSHTOUCHY, cFLOWERSTOUCHY, cTALLGRASSTOUCHY,
  cSLASHNEXTTOUCHY, cSLASHNEXTITEMTOUCHY, cBUSHNEXTTOUCHY, cMAX


  finished:
  cDAMAGE1, cDAMAGE2, cDAMAGE3, cDAMAGE4, cDAMAGE5, cDAMAGE6, cDAMAGE7,
  cWATER, cDOCK, cCVUP, cCVDOWN, cCVLEFT, cCVRIGHT, cWALKSLOW, cOVERHEAD,
  cEYEBALL_A, cEYEBALL_B, cBLOCKARROW1, cBLOCKARROW2, cBLOCKARROW3, cBLOCKBRANG1,
  cBLOCKBRANG2, cBLOCKBRANG3, cBLOCKSBEAM, cMAGICSPONGE, cBLOCKFIREBALL,
  cBLOCKALL,

*/

comboclass default_combo_classes[cMAX] =
{
//  name                                           a      b      c       d01    d02    d03    d04    d05    d06    d07    d08    d09    d10    d11    d12    d13    d14    d15    d16    d17    d18    d19    d20    d21    d22    d23    d24    d25    d26    d27    d28    d29    d30    d31    d32          e        f        g      h        i      j        k        l      m      n      o        p      q      r      s      t        u      v        w      x      y        z     aa     ab     ac     ad     ae     af     ag     ah     ai     aj     ak     al     am     an     ao     ap     aq      ar      as      at01   at02   at03   at04   at05   at06   at07   at08   at09   at10   at11   at12   at13   at14   at15   at16   at17   at18   at19   at20   at21   at22   at23   at24   at25   at26   at27   at28   at29   at30   at31   at32         au     av       aw       ax       ay     az     ba     bb     bc     bd     be     bf     bg     bh     bi
    { "(None)",                                      0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Stairs [A]",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Cave (Walk Down) [A]",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Water",                                       0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Armos",                                       0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Grave",                                       0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Dock",                                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     1,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "-Unused",                                      0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Push (Wait)",                                 0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Push (Heavy)",                                0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Push (Heavy, Wait)",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Left Statue",                                 0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Right Statue",                                0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slow Walk",                                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Conveyor Up",                                 0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,      -2,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Conveyor Down",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       2,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Conveyor Left",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },      -2,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Conveyor Right",                              0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       2,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Swim Warp [A]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Dive Warp [A]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Ladder or Hookshot",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Secrets (Temporary)",                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Secrets (Permanent)",                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "-Unused",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     1,     0 },
    { "Slash",                                       0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slash (Item)",                                0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Push (Very Heavy)",                           0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Push (Very Heavy, Wait)",                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Pound",                                       0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Hookshot Grab",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
//  name                                           a      b      c       d01    d02    d03    d04    d05    d06    d07    d08    d09    d10    d11    d12    d13    d14    d15    d16    d17    d18    d19    d20    d21    d22    d23    d24    d25    d26    d27    d28    d29    d30    d31    d32          e        f        g      h        i      j        k        l      m      n      o        p      q      r      s      t        u      v        w      x      y        z     aa     ab     ac     ad     ae     af     ag     ah     ai     aj     ak     al     am     an     ao     ap     aq      ar      as      at01   at02   at03   at04   at05   at06   at07   at08   at09   at10   at11   at12   at13   at14   at15   at16   at17   at18   at19   at20   at21   at22   at23   at24   at25   at26   at27   at28   at29   at30   at31   at32         au     av       aw       ax       ay     az     ba     bb     bc     bd     be     bf     bg     bh     bi
    { "-Hookshot Bridge",                            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Damage (1/2 Heart)",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,    -  8,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Damage (1 Heart)",                            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,    - 16,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Damage (2 hearts)",                           0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,    - 32,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Damage (4 Hearts)",                           0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,    - 64,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Center Statue",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Trap (Horizontal, Line of Sight)",            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Trap (Vertical, Line of Sight)",              0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Trap (4-Way)",                                0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Trap (Horizontal, Constant)",                 0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Trap (Vertical, Constant)",                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Direct Warp [A]",                             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Hookshot Only",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Overhead",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "No Flying Enemies",                           4,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Magic Mirror (4-Way)",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Magic Mirror (Up-Left, Down-Right)",          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Magic Mirror (Up-Right, Down-Left)",          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Magic Prism (3-Way)",                         0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Magic Prism (4-Way)",                         0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Block Magic",                                 0,     0,     0,  {     0,    32,     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,    64,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   255 },
    { "Cave (Walk Up) [A]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Eyeball (8-Way A)",                                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     1,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Eyeball (8-Way B)",                                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     2,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "No Jumping Enemies",                          2,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Bush",                                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Flowers",                                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Tall Grass",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Shallow Water",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Lock Block (Normal)",                         0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
//  name                                           a      b      c       d01    d02    d03    d04    d05    d06    d07    d08    d09    d10    d11    d12    d13    d14    d15    d16    d17    d18    d19    d20    d21    d22    d23    d24    d25    d26    d27    d28    d29    d30    d31    d32          e        f        g      h        i      j        k        l      m      n      o        p      q      r      s      t        u      v        w      x      y        z     aa     ab     ac     ad     ae     af     ag     ah     ai     aj     ak     al     am     an     ao     ap     aq      ar      as      at01   at02   at03   at04   at05   at06   at07   at08   at09   at10   at11   at12   at13   at14   at15   at16   at17   at18   at19   at20   at21   at22   at23   at24   at25   at26   at27   at28   at29   at30   at31   at32         au     av       aw       ax       ay     az     ba     bb     bc     bd     be     bf     bg     bh     bi
    { "Lock Block (Normal, Copycat)",                0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Lock Block (Boss)",                           0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Lock Block (Boss, Copycat)",                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Ladder Only",                                 0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "BS Grave",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Treasure Chest (Normal)",                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Treasure Chest (Normal, Copycat)",            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Treasure Chest (Locked)",                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Treasure Chest (Locked, Copycat)",            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Treasure Chest (Boss)",                       0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Treasure Chest (Boss, Copycat)",              0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Reset Room",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Save Point",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Save-Quit Point",                             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Cave (Walk Down) [B]",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Cave (Walk Down) [C]",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Cave (Walk Down) [D]",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Stairs [B]",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Stairs [C]",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Stairs [D]",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Direct Warp [B]",                             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Direct Warp [C]",                             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Direct Warp [D]",                             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Cave (Walk Up) [B]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Cave (Walk Up) [C]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Cave (Walk Up) [D]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Swim Warp [B]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Swim Warp [C]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Swim Warp [D]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Dive Warp [B]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
//  name                                           a      b      c       d01    d02    d03    d04    d05    d06    d07    d08    d09    d10    d11    d12    d13    d14    d15    d16    d17    d18    d19    d20    d21    d22    d23    d24    d25    d26    d27    d28    d29    d30    d31    d32          e        f        g      h        i      j        k        l      m      n      o        p      q      r      s      t        u      v        w      x      y        z     aa     ab     ac     ad     ae     af     ag     ah     ai     aj     ak     al     am     an     ao     ap     aq      ar      as      at01   at02   at03   at04   at05   at06   at07   at08   at09   at10   at11   at12   at13   at14   at15   at16   at17   at18   at19   at20   at21   at22   at23   at24   at25   at26   at27   at28   at29   at30   at31   at32         au     av       aw       ax       ay     az     ba     bb     bc     bd     be     bf     bg     bh     bi
    { "Dive Warp [C]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Dive Warp [D]",                               0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     1,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,     0,     0 },
    { "Stairs [Random]",                             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Direct Warp [Random]",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Auto Side Warp [A]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Auto Side Warp [B]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Auto Side Warp [C]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Auto Side Warp [D]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Auto Side Warp [Random]",                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Sensitive Warp [A]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Sensitive Warp [B]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Sensitive Warp [C]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Sensitive Warp [D]",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Sensitive Warp [Random]",                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Secrets (Sensitive, Temp)",             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Secrets (Sensitive, Perm.)",            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Next",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Next (Same)",                           0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Next (All)",                            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Step->Next (Copycat)",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "No Enemies",                                  7,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Block Arrow (L1)",                            0,     0,     0,  {     0,     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     1 },
    { "Block Arrow (L1, L2)",                        0,     0,     0,  {     0,     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     2 },
    { "Block Arrow (All)",                           0,     0,     0,  {     0,     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   255 },
    { "Block Brang (L1)",                            0,     0,     0,  {     8,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     1 },
    { "Block Brang (L1, L2)",                        0,     0,     0,  {     8,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     2 },
    { "Block Brang (All)",                           0,     0,     0,  {     8,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   255 },
    { "Block Sword Beam",                            0,     0,     0,  {     4,     0,     0,    16,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,    16,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   255 },
    { "Block All",                                   0,     0,     0,  {   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255,   255 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   255 },
    { "Block Fireball",                              0,     0,     0,  {     0,     0,     2,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     2,     0,     2,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,   255 },
//  name                                           a      b      c       d01    d02    d03    d04    d05    d06    d07    d08    d09    d10    d11    d12    d13    d14    d15    d16    d17    d18    d19    d20    d21    d22    d23    d24    d25    d26    d27    d28    d29    d30    d31    d32          e        f        g      h        i      j        k        l      m      n      o        p      q      r      s      t        u      v        w      x      y        z     aa     ab     ac     ad     ae     af     ag     ah     ai     aj     ak     al     am     an     ao     ap     aq      ar      as      at01   at02   at03   at04   at05   at06   at07   at08   at09   at10   at11   at12   at13   at14   at15   at16   at17   at18   at19   at20   at21   at22   at23   at24   at25   at26   at27   at28   at29   at30   at31   at32         au     av       aw       ax       ay     az     ba     bb     bc     bd     be     bf     bg     bh     bi
    { "Damage (8 hearts)",                           0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,    -128,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Damage (16 hearts)",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,    -256,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Damage (32 hearts)",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,    -512,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "-Unused",                                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Spinning Tile (Immediate)",                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "-Unused",									   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Screen Freeze (Except FFCs)",                 0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Screen Freeze (FFCs Only)",                   0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "No Ground Enemies",                           1,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slash->Next",                                 0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slash->Next (Item)",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Bush->Next",                                  0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slash (Continuous)",                          0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slash (Item, Continuous)",                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Bush (Continuous)",                           0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Flowers (Continuous)",                        0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Tall Grass (Continuous)",                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slash->Next (Continuous)",                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Slash->Next (Item, Continuous)",              0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Bush->Next (Continuous)",                     0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Eyeball (4-Way)",                             0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     3,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Tall Grass->Next",                            0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Script 1",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Script 2",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Script 3",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Script 4",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },
    { "Script 5",                                    0,     0,     0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,       0,       0,     0,       0,     0,       0,       0,     0,     0,     0,       0,     0,     0,     0,     0,       0,     0,       0,     0,     0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,       0,  {     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 },       0,     0,       0,       0,       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,     0 }
};

itemdata default_items[iLast]=
{
// The first 7 values should be 0! (Because qst.dat overwrites them.)
// tile/misc etc. family                  fam_type         power           flags                                                                script  count   amount                           setmax               max                  playsound         collect_script                  initiald[8]                                 initiala[2]          wpn                wpn2               wpn3              wpn4  wpn5  wpn6  wpn7  wpn8  wpn9  wpn10 pickup_hearts  misc1                                                        misc2                    misc3                                                  misc4                           misc5 misc6 misc7 misc8 misc9 misc10 magic usesound
    {0,0,0,0,0,0,0, itype_rupee,            i_rupee,         0,              0,                                                                      0,     1,     1|0x8000,                        0,                   0,                  WAV_CHIME,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_rupee,            i_5rupee,        0,              0,                                                                      0,     1,     5|0x8000,                        0,                   0,                  WAV_CHIME,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_heart,            1,               0,              0,                                                                      0,     0,     HP_PER_HEART,                    0,                   0,                  WAV_PLINK,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bomb,             i_bomb,          4,              ITEM_GAMEDATA,                                                          0,     2,     4,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wBOMB,             wBOOM,             0,                0,    0,    0,    0,    0,    0,    0,        0,     50,                                                              1,                       2,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_BOMB           },
    {0,0,0,0,0,0,0, itype_clock,            1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_sword,            i_sword,         1,              ITEM_FLAG1|ITEM_FLAG2|ITEM_GAMEDATA|ITEM_FLAG4,                         0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wSWORD,            wSWORDSLASH,       wSWORD,           0,    0,    0,    0,    0,    0,    0,        0,    100,                                                            100,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_SWORD          },
    {0,0,0,0,0,0,0, itype_sword,            i_wsword,        2,              ITEM_FLAG1|ITEM_FLAG2|ITEM_GAMEDATA|ITEM_FLAG4,                         0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wWSWORD,           wWSWORDSLASH,      wWSWORD,          0,    0,    0,    0,    0,    0,    0,        0,    100,                                                            100,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_SWORD          },
    {0,0,0,0,0,0,0, itype_sword,            i_msword,        4,              ITEM_FLAG1|ITEM_FLAG2|ITEM_GAMEDATA|ITEM_FLAG4,                         0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wMSWORD,           wMSWORDSLASH,      wMSWORD,          0,    0,    0,    0,    0,    0,    0,        0,    100,                                                            100,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_SWORD          },
    {0,0,0,0,0,0,0, itype_shield,           i_largeshield,   0,              ITEM_GAMEDATA|ITEM_EDIBLE|ITEM_KEEPOLD,                                 0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      shROCK|shARROW|shBRANG|shFIREBALL|shSWORD|shMAGIC|shSCRIPT,     0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_CHINK          },
    {0,0,0,0,0,0,0, itype_key,              1,               0,              0,                                                                      0,     5,     1,                               0,                   0,                  WAV_PLINK,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_candle,           i_bcandle,       1,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 wFIRE,            0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_FIRE           },
    {0,0,0,0,0,0,0, itype_candle,           i_rcandle,       1,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 wFIRE,            0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_FIRE           },
    {0,0,0,0,0,0,0, itype_letter,           i_letter,        0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_arrow,            i_warrow,        2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wARROW,            0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_ARROW          },
    {0,0,0,0,0,0,0, itype_arrow,            i_sarrow,        4,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wSARROW,           wSSPARKLE,         0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_ARROW          },
    {0,0,0,0,0,0,0, itype_bow,              i_shortbow,      1,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bait,             i_bait,          0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wBAIT,             0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      768,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_ring,             i_bring,         2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      spBLUE,                                                         0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_ring,             i_rring,         4,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      spRED,                                                          0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bracelet,         i_bracelet1,     1,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_triforcepiece,    1,               0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,             0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              1,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_map,              1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_compass,          1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_brang,            i_wbrang,        0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wBRANG,            0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     36,                                                              0,                       shBRANG|shROCK|shARROW,                                0,                              0,    0,    0,    0,    0,    0,     0,    WAV_BRANG          },
    {0,0,0,0,0,0,0, itype_brang,            i_mbrang,        0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wMBRANG,           wMSPARKLE,         0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       shBRANG|shROCK|shARROW|shFIREBALL|shSWORD|shMAGIC,     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_BRANG          },
    {0,0,0,0,0,0,0, itype_wand,             i_wand,          2,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wWAND,             wSWORDSLASH,       wMAGIC,           0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_WAND           },
    {0,0,0,0,0,0,0, itype_raft,             i_raft,          0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_SECRET         },
    {0,0,0,0,0,0,0, itype_ladder,           i_ladder,        1,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_heartcontainer,   1,               0,              0,                                                                      0,     0,     HP_PER_HEART,                    HP_PER_HEART,        24*HP_PER_HEART,    WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_potion,           i_bpotion,       0,              ITEM_GAMEDATA|ITEM_DOWNGRADE|ITEM_COMBINE|ITEM_FLAG1|ITEM_FLAG2,        0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,    100,                                                            100,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_potion,           i_rpotion,       0,              ITEM_GAMEDATA|ITEM_DOWNGRADE|ITEM_KEEPOLD|ITEM_GAINOLD|0x30,            0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,    100,                                                            100,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_whistle,          i_recorder,      0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wWIND,             0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      3,                                                              8,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_WHISTLE        },
    {0,0,0,0,0,0,0, itype_book,             i_book,          2,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wMAGIC,            0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_WAND           },
    {0,0,0,0,0,0,0, itype_magickey,         i_magickey,      0xFF,           ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_fairy,            1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      3,                                                              0,                      50,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_SCALE          },
    {0,0,0,0,0,0,0, itype_brang,            i_fbrang,        2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wFBRANG,           0,                 wFSPARKLE,        0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       shBRANG|shROCK|shARROW|shFIREBALL|shSWORD|shMAGIC,     shFIREBALL|shSWORD|shMAGIC,     0,    0,    0,    0,    0,    0,     0,    WAV_BRANG          },
    {0,0,0,0,0,0,0, itype_sword,            i_xsword,        8,              ITEM_FLAG1|ITEM_FLAG2|ITEM_GAMEDATA|ITEM_FLAG4,                         0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wXSWORD,           wXSWORDSLASH,      wXSWORD,          0,    0,    0,    0,    0,    0,    0,        0,    100,                                                            100,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_SWORD          },
    {0,0,0,0,0,0,0, itype_shield,           i_mirrorshield,   0,             ITEM_GAMEDATA|ITEM_KEEPOLD,                                             0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      shROCK|shARROW|shBRANG|shFIREBALL|shSWORD|shMAGIC|shFLAME|shSCRIPT, shFIREBALL|shMAGIC|shSCRIPT, 0,                                            0,                              0,    0,    0,    0,    0,    0,     0,    WAV_CHINK          },
    {0,0,0,0,0,0,0, itype_rupee,            i_20rupee,       0,              0,                                                                      0,     1,     20|0x8000,                       0,                   0,                  WAV_CHIME,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_rupee,            i_50rupee,       0,              0,                                                                      0,     1,     50|0x8000,                       0,                   0,                  WAV_CHIME,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_rupee,            i_200rupee,      0,              0,                                                                      0,     1,     200|0x8000,                      0,                   0,                  WAV_CHIME,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_wallet,           i_swallet,       0,              ITEM_GAMEDATA,                                                          0,     1,     0,                             500,                 500,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_wallet,           i_lwallet,       0,              ITEM_GAMEDATA,                                                          0,     1,     0,                             999,                 999,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_misc,             1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      4,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_triforcepiece,    1,               0,              0,														               0,    -1,     0,                               0,                   0,                  WAV_CLEARED,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_misc,             1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      5,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_misc,             1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      2,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_misc,             1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      3,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_sbomb,            i_sbomb,         16,             ITEM_GAMEDATA,                                                          0,     6,     1,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wSBOMB,            wSBOOM,            0,                0,    0,    0,    0,    0,    0,    0,        0,     50,                                                              1,                       8,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_BOMB           },
    {0,0,0,0,0,0,0, itype_heartpiece,       1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_amulet,           i_amulet1,       0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_flippers,         i_flippers,      0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_hookshot,         i_hookshot,      0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wHSHEAD,           wHSCHAIN_H,        wHSCHAIN_V,       wHSHANDLE,    0,    0,    0,    0,    0,    0,        0,     8,                                                            100,                       shBRANG|shROCK|shARROW|shFIREBALL,                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_HOOKSHOT       },
    {0,0,0,0,0,0,0, itype_lens,             i_lens,          0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     60,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     2,    WAV_ZN1LENSON      },
    {0,0,0,0,0,0,0, itype_hammer,           i_hammer,        4,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wHAMMER,           iwHammerSmack,     0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_HAMMER         },
    {0,0,0,0,0,0,0, itype_boots,            i_boots,         7,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bracelet,         i_bracelet2,     2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_arrow,            i_garrow,        8,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wGARROW,           wGSPARKLE,         0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_ARROW          },
    {0,0,0,0,0,0,0, itype_magiccontainer,   1,               0,              0,                                                                      0,     4, (MAGICPERBLOCK|0x8000),          MAGICPERBLOCK,       MAGICPERBLOCK*8,    WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_magic,            1,               0,              0,                                                                      0,     4, (MAGICPERBLOCK)|0x8000,          0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_magic,            1,               0,              0,                                                                      0,     4, (MAGICPERBLOCK<<3)|0x8000,       0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_ring,             i_gring,         8,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      spGOLD,                                                         0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_killem,           1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_amulet,           i_amulet2,       0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_dinsfire,         i_dinsfire,      8,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wDINSFIRE1A,       wDINSFIRE1B,      wDINSFIRES1A,      wDINSFIRES1B,  0, 0, 0, 0,    0,    0,        0,     32,                                                            200,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,    32,    WAV_ZN1DINSFIRE    },
    {0,0,0,0,0,0,0, itype_faroreswind,      i_faroreswind,   0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,    32,    WAV_ZN1FARORESWIND },
    {0,0,0,0,0,0,0, itype_nayruslove,       i_nayruslove,    0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wNAYRUSLOVE1A, wNAYRUSLOVE1B,wNAYRUSLOVES1A, wNAYRUSLOVES1B,iwNayrusLoveShieldFront, wNAYRUSLOVE2A, wNAYRUSLOVE2B, wNAYRUSLOVES2A, wNAYRUSLOVES2B, iwNayrusLoveShieldBack, 0, 512, 0,                  0,                                                     0,                              0,    0,    0,    0,    0,    0,    64,    WAV_ZN1NAYRUSLOVE1 },
    {0,0,0,0,0,0,0, itype_bosskey,          1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bow,              i_longbow,       3,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_fairy,            1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      3,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_SCALE          },
    {0,0,0,0,0,0,0, itype_arrowammo,        i_arrowa,        0,              0,                                                                      0,     3,     1,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_arrowammo,        i_5arrowa,       0,              0,                                                                      0,     3,     5,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_arrowammo,        i_10arrowa,      0,              0,                                                                      0,     3,    10,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_arrowammo,        i_30arrowa,      0,              0,                                                                      0,     3,    30,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_quiver,           i_quiver,        0,              ITEM_GAMEDATA,                                                          0,     3,     0,                              30,                  30,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_quiver,           i_quiverl2,      0,              ITEM_GAMEDATA,                                                          0,     3,     0,                              60,                  60,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_quiver,           i_quiverl3,      0,              ITEM_GAMEDATA,                                                          0,     3,     0,                              99,                  99,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombammo,         i_bomba,         0,              0,                                                                      0,     2,     1,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombammo,         i_4bomba,        0,              0,                                                                      0,     2,     4,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombammo,         i_8bomba,        0,              0,                                                                      0,     2,     8,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombammo,         i_30bomba,       0,              0,                                                                      0,     2,    30,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombbag,          i_bombbag1,      0,              ITEM_GAMEDATA,                                                          0,     2,     0,                              30,                  30,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombbag,          i_bombbag2,      0,              ITEM_GAMEDATA,                                                          0,     2,     0,                              60,                  60,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombbag,          i_bombbag3,      0,              ITEM_GAMEDATA,                                                          0,     2,     0,                              99,                  99,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_lkey,             1,			   0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_PLINK,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_misc,             1,               0,              0,                                                                      0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      1,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_rupee,            i_10rupee,       0,              0,                                                                      0,     1,     10|0x8000,                       0,                   0,                  WAV_CHIME,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_rupee,            i_100rupee,      0,              0,                                                                      0,     1,     100|0x8000,                      0,                   0,                  WAV_CHIME,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_cbyrna,           i_cbyrna,        1,              ITEM_GAMEDATA|ITEM_FLAG1|ITEM_FLAG4,                                    0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wCBYRNA,           wCBYRNASLASH,      wCBYRNAORB,       0,    0,    0,    0,    0,    0,    0,        0,      4,                                                             16,                       1,                                                     0,                              0,    0,    0,    0,    0,    0,     1,    WAV_ZN2CANE                },
    {0,0,0,0,0,0,0, itype_hookshot,         i_longshot,      0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    wLSHEAD,           wLSCHAIN_H,        wLSCHAIN_V,       wLSHANDLE,    0,    0,    0,    0,    0,    0,        0,     99,                                                            100,                       shBRANG|shROCK|shARROW|shFIREBALL,                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_HOOKSHOT       },
    {0,0,0,0,0,0,0, itype_letter,           i_letter_used,   0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_rocs,             i_rocs,          2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_ZN1JUMP        },
    {0,0,0,0,0,0,0, itype_hoverboots,       i_hoverboots,    0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    iwHover,           0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     45,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_ZN1HOVER       },
    {0,0,0,0,0,0,0, itype_shield,           i_smallshield,   0,              ITEM_GAMEDATA|ITEM_KEEPOLD,                                             0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      shROCK|shARROW|shBRANG,                                                           0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_CHINK          },
    {0,0,0,0,0,0,0, itype_spinscroll,       i_spinscroll1,   2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      1,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_ZN1SPINATTACK  },
    {0,0,0,0,0,0,0, itype_crossscroll,      i_crossscroll,   1,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_quakescroll,      i_quakescroll1,  2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0x10,                                                          64,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    WAV_BOMB           },
    {0,0,0,0,0,0,0, itype_quakescroll2,     i_quakescroll2,  3,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0x20,                                                         192,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     8,    WAV_BOMB           },
    {0,0,0,0,0,0,0, itype_spinscroll2,      i_spinscroll2,   2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     20,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     8,    WAV_ZN1SPINATTACK  },
    {0,0,0,0,0,0,0, itype_whispring,        i_whispring1,    1,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      3,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_whispring,        i_whispring2,    0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      3,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_chargering,       i_chargering1,   0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     64,                                                            128,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_chargering,       i_chargering2,   0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     32,                                                             64,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_perilscroll,      i_perilscroll,   0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      1,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_wallet,           i_mwallet,       1,              ITEM_GAMEDATA,                                                          0,     1,     0,                             999,                 999,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_quiver,           i_quiverl4,      1,              ITEM_GAMEDATA,                                                          0,     3,     0,                              99,                  99,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bombbag,          i_bombbag4,      1,              ITEM_GAMEDATA,                                                          0,     2,     0,                              99,                  99,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_bracelet,         i_oldglove,      1,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_ladder,           i_ladder2,       2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_wealthmedal,      i_wealthmedal,   0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     75,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_wealthmedal,      i_wealthmedal2,  0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     50,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_wealthmedal,      i_wealthmedal3,  0,              ITEM_GAMEDATA|ITEM_FLAG1,                                               0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     25,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_heartring,        i_heartring,     0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      4,                                                              0x400,                   0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_heartring,        i_heartring2,    0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      4,                                                              0x200,                   0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_heartring,        i_heartring3,    0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      4,                                                              0x100,                   0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_magicring,        i_magicring,     0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      4,                                                              0x400,                   0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_magicring,        i_magicring2,    0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      4,                                                              0x200,                   0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_magicring,        i_magicring3,    0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      4,                                                              0x100,                   0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_magicring,        i_magicring4,    1,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_agony,            1,               0,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,     30,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_stompboots,       1,               1,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_perilring,        1,               2,              ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      1,                                                              0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  },
    {0,0,0,0,0,0,0, itype_whimsicalring,    1,               0xFF,           ITEM_GAMEDATA,                                                          0,    -1,     0,                               0,                   0,                  WAV_SCALE,               0,    {     0,    0,    0,    0,    0,    0,    0,    0     },    {     0,    0     },    0,                 0,                 0,                0,    0,    0,    0,    0,    0,    0,        0,      0xF,                                                            0,                       0,                                                     0,                              0,    0,    0,    0,    0,    0,     0,    0                  }
};

guydata default_guys[OLDMAXGUYS] =
{
    // flags         flags2         tile   width,  height  s_tile s_width s_height etile e_width e_height  hp family         cset    anim         e_anim,            frate e_frate    dp      wdp    weapon         rate  hrate   step  homing  grumble  item_set         misc1          misc2                misc3          misc4          m5    m6    m7      m8    m9    m10   m11   m12   m13   m14   m15     bgsfx        bosspal          extend
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeNONE,           0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,      84,     1,    0,      0,    0,    0,       84,     1,     1,      2,    eeGUY,            8,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,      85,     1,    0,      0,    0,    0,       85,     1,     1,      2,    eeGUY,            8,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,      86,     1,    0,      0,    0,    0,       86,     1,     1,      2,    eeGUY,            6,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,     116,     1,    0,      0,    0,    0,      116,     1,     1,      2,    eeGUY,            8,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000000,    0x00000000,      65,     1,    0,      0,    0,    0,       65,     1,     1,      2,    eeGUY,            8,    aFLIP,         aFLIP,            12,     24,     2,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    { 0x00000000,    0x00000000,      63,     1,    0,      0,    0,    0,       63,     1,     1,      2,    eeGUY,            8,    a2FRM,         a2FRM,             8,     16,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,     132,     1,    0,      0,    0,    0,      132,     1,     1,      2,    eeGUY,            8,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,      35,     1,    0,      0,    0,    0,       35,     1,     1,      2,    eeGUY,            6,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,      87,     1,    0,      0,    0,    0,       87,     1,     1,      2,    eeGUY,            8,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    //10
    { 0x00000001,    0x00000000,     259,     1,    0,      0,    0,    0,      259,     1,     1,      2,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     1,     1,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,     1,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    //20 eOCTO1S
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     3420,    16,     3,      2,    eeWALK,           8,    aOCTO,         a4FRM4DIRF,       12,     12,     2,     2,    ewRock,          4,     3,     50,     64,    1,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eOCTO2S
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     3540,    16,     3,      4,    eeWALK,           7,    aOCTO,         a4FRM4DIRF,       12,     12,     2,     2,    ewRock,          4,     5,     50,     64,    2,    isBOMBS,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eOCTO1F
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     3480,    16,     3,      2,    eeWALK,           8,    aOCTO,         a4FRM4DIRF,       12,     12,     2,     2,    ewRock,          6,     3,    100,    128,    1,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eOCTO2F
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     3600,    16,     3,      4,    eeWALK,           7,    aOCTO,         a4FRM4DIRF,       12,     12,     2,     2,    ewRock,          6,     5,    100,    128,    2,    isBOMBS,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eTEK1
    { 0x00000000,    0x00000000,     103,     2,    0,      0,    0,    0,     2340,    16,     2,      2,    eeTEK,            8,    aTEK,          aNEWTEK,          32,     32,     2,     2,    wNone,           0,     0,    250,      0,    0,    isDEFAULT,         24,              3,               50,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eTEK2
    { 0x00000000,    0x00000000,     103,     2,    0,      0,    0,    0,     2380,    16,     2,      2,    eeTEK,            7,    aTEK,          aNEWTEK,          32,     32,     2,     2,    wNone,           0,     0,    250,      0,    0,    isMAGICMONEY,      80,             16,               50,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eLEV1
    { 0x00000000,    0x00000000,      96,     5,    0,      0,    0,    0,     3040,    16,     3,      4,    eeLEV,            8,    aLEV,          aNEWLEV,          40,     16,     2,     2,    wNone,           0,     0,     50,      0,    0,    isMONEY,            0,              8,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,edCHINK,0,0,0 }, 0, WAV_EDEAD, },
    // eLEV2
    { 0x00000000,    0x00000000,      96,     5,    0,      0,    0,    0,     3100,    16,     3,      8,    eeLEV,            7,    aLEV,          aNEWLEV,          40,     16,     4,     2,    wNone,           8,     0,     50,      0,    0,    isMAGICMONEY,       1,              8,               17,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,edCHINK,0,0,0 }, 0, WAV_EDEAD, },
    // eMOBLIN1
    { 0x00000000,    0x00000000,     114,     4,    0,      0,    0,    0,     3840,    16,     3,      4,    eeWALK,           8,    aWALK,         a4FRM4DIRF,       12,     16,     2,     2,    ewArrow,         5,     4,     50,    128,    3,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eMOBLIN2
    { 0x00000000,    0x00000000,     114,     4,    0,      0,    0,    0,     3900,    16,     3,      6,    eeWALK,           9,    aWALK,         a4FRM4DIRF,       12,     16,     2,     2,    ewArrow,         8,     6,     50,    128,    4,    isBOMBS,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // 30 eLYNEL1
    { 0x00000000,    0x00000000,     105,     4,    0,      0,    0,    0,     4100,    16,     3,      8,    eeWALK,           8,    aWALK,         a4FRM4DIRF,       12,     16,     4,     8,    ewSword,         6,     4,     50,    128,    3,    isMAGICMONEY,       0,              0,                0,               0,           0,    2,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eLYNEL2
    { 0x00000000,    0x00000000,     105,     4,    0,      0,    0,    0,     4160,    16,     3,     12,    eeWALK,           7,    aWALK,         a4FRM4DIRF,       12,     16,     8,     8,    ewSword,         6,     4,     50,    128,    3,    isMAGICBOMBS,       0,              0,                0,               0,           0,    2,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // ePEAHAT
    { 0x00000000,    0x00000000,     101,     2,    0,      0,    0,    0,     2300,    16,     2,      4,    eePEAHAT,         8,    a2FRMPOS,      a4FRMPOS8DIR,      0,      0,     2,     2,    wNone,           4,     8,     62,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNONLY,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eZORA
    { 0x00000000,    0x00000002,     112,     2,    0,     96,    2,    0,     2460,    16,     6,      4,    eeZORA,           9,    aZORA,         aNEWZORA,        256,    256,     2,     2,    ewFireball,      0,     0,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eROCK
    { 0x00000008,    0x00000004,     118,     2,    0,      0,    0,    0,     3220,    16,     2,      2,    eeROCK,           8,    a2FRM,         aNEWZORA,         12,     16,     2,     2,    wNone,           0,     0,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eGHINI1
    { 0x00000000,    0x00000000,     109,     2,    0,      0,    0,    0,     2200,    16,     1,     18,    eeWALK,           7,    aGHINI,        a4FRMPOS4DIR,    256,    256,     4,     4,    wNone,           4,     0,     50,      0,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGHINI2
    { 0x00004000,    0x00001000,     109,     2,    0,      0,    0,    0,     2220,    16,     2,     18,    eeGHINI,          7,    aGHINI,        a4FRMPOS8DIR,    256,    256,     4,     4,    wNone,           4,     12,    62,      0,    0,    isMONEY,            1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORIGNORE,edX,0,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eARMOS
    { 0x00000010,    0x00000800,      88,     4,    0,      0,    0,    0,     2260,    16,     2,      6,    eeWALK,           8,    aARMOS,        aARMOS4,          16,     16,     4,     4,    wNone,           6,     0,     50,    128,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    4,  150,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eKEESE1
    { 0x00000001,    0x00000000,     123,     2,    0,      0,    0,    0,     1580,    16,     2,      1,    eeKEESE,          7,    a2FRMPOS,      a4FRMPOS8DIR,      0,      0,     2,     2,    wNone,           2,     8,     62,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eKEESE2
    { 0x00000001,    0x00000000,     123,     2,    0,      0,    0,    0,     1620,    16,     2,      1,    eeKEESE,          8,    a2FRMPOS,      a4FRMPOS8DIR,      0,      0,     2,     2,    wNone,           2,     8,     62,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // 40 eKEESE3
    { 0x00000001,    0x00000000,     123,     2,    0,      0,    0,    0,     1660,    16,     2,      1,    eeKEESE,          9,    a2FRMPOS,      a4FRMPOS8DIR,      0,      0,     2,     2,    wNone,           2,     8,     62,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eSTALFOS
    { 0x00000000,    0x00000000,     125,     1,    0,      0,    0,    0,     3960,    16,     1,      4,    eeWALK,           8,    aFLIP,         a4FRM4DIR,        16,     16,     2,     2,    wNone,           4,     0,     50,    128,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGEL
    { 0x00000001,    0x00000000,     120,     2,    0,      0,    0,    0,     1780,    16,     1,      1,    eeWALK,           9,    a2FRM,         a4FRM4DIR,         4,      8,     2,     2,    wNone,           4,    16,    100,     64,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eZOL
    { 0x00000000,    0x00000000,     137,     2,    0,      0,    0,    0,     1800,    16,     1,      4,    eeWALK,           9,    a2FRM,         a4FRM4DIR,        16,     16,     4,     4,    wNone,           4,    16,     40,    144,    0,    isMONEY,            0,              e2tSPLITHIT,      eGEL,            2,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eROPE
    { 0x00000000,    0x00000000,     126,     2,    0,      0,    0,    0,     2420,    16,     1,      2,    eeWALK,           8,    aROPE,         a4FRM4DIR,        16,     16,     2,     2,    wNone,           4,     0,     50,      0,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,      0, e9tROPE, 0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGORIYA1
    { 0x00000000,    0x00000000,     130,     4,    0,      0,    0,    0,     3720,    16,     3,      6,    eeWALK,           8,    aWALK,         a4FRM4DIRF,       12,     12,     2,     4,    ewBrang,         6,     5,     50,    128,    4,    isBOMBS,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGORIYA2
    { 0x00000000,    0x00000000,     130,     4,    0,      0,    0,    0,     3780,    16,     3,     10,    eeWALK,           7,    aWALK,         a4FRM4DIRF,       12,     12,     4,     4,    ewBrang,         6,     6,     50,    128,    4,    isLIFE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eTRAP
    { 0x00000008,    0x00000248,     122,     1,    0,   2020,    0,    0,     2000,    16,     3,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,        16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eWALLM
    { 0x00000000,    0x00000000,     128,     2,    0,      0,    0,    0,     2580,    16,     1,      4,    eeWALLM,          7,    aWALLM,        aNEWWALLM,        16,     16,     2,     2,    wNone,           0,     0,     40,      0,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eDKNUT1
    { 0x11000000,    0x00000000,     140,     5,    0,    860,    5,    0,     4220,    16,     1,      8,    eeWALK,           8,    aDWALK,        a4FRM4DIR,        16,     16,     4,     4,    wNone,           5,     0,     50,    144,    0,    isMAGICBOMBS,       0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edCHINK,edIGNORE,0,edCHINK,0,0,0,0,0,0,0,edCHINK,edCHINK,edCHINK,0,0 }, 0, WAV_EDEAD, },
    // 50 eDKNUT2
    { 0x11000000,    0x00000000,     140,     5,    0,    860,    5,    0,     4240,    16,     1,     16,    eeWALK,           7,    aDWALK,        a4FRM4DIR,        16,     16,     8,     4,    wNone,           4,     0,     67,    160,    0,    isMAGICLIFE,        0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edCHINK,edIGNORE,0,edCHINK,0,0,0,0,0,0,0,edCHINK,edCHINK,edCHINK,0,0 }, 0, WAV_EDEAD, },
    // eBUBBLEST
    { 0x00000008,    0x00000001,     111,     1,    0,      0,    0,    0,     1880,    16,     1,      2,    eeWALK,           9,    aFLIP,         a4FRM4DIR,         8,      8,     0,     0,    wNone,           4,     0,    100,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,e7tTEMPJINX, 0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,   { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eVIRE
    { 0x00000000,    0x00000000,     165,     4,    0,      0,    0,    0,     1760,    16,     1,      8,    eeWALK,           7,    aVIRE,         a4FRM4DIR,        20,     20,     4,     4,    wNone,           4,     0,     50,     64,    0,    isBOMBS,            0,              e2tSPLITHIT,          eKEESE2,     2,           0,    0,    0,      0, e9tVIRE, 0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eLIKE
    { 0x00000000,    0x00000000,     162,     3,    0,      0,    0,    0,     1860,    16,     1,     18,    eeWALK,           8,    a3FRM,         a4FRM4DIR,        32,     32,     4,     4,    wNone,           4,     0,     50,     64,    0,    isNONE,             0,              0,                0,               0,           0,    0,e7tEATITEMS,95,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGIBDO
    { 0x00000000,    0x00000000,     136,     1,    0,      0,    0,    0,     2140,    16,     1,     14,    eeWALK,           7,    aFLIP,         a4FRM4DIR,        16,     16,     8,     8,    wNone,           4,     0,     50,    128,    0,    isBOMBS,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // ePOLSV
    { 0x00000000,    0x00000000,     134,     2,    0,   2180,    0,    0,     2160,    16,     2,     20,    eeWALK,           6,    a2FRM,         a4FRM4DIR,        16,     16,     8,     8,    wNone,           4,    10,     50,     32,    0,    isMONEY,            0,              0,                0,               0,        0,    0,    0,    0, e9tPOLSVOICE, 0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,edIGNORE,edIGNORE,ed1HKO,edIGNORE,0,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edCHINK,0 }, 0, WAV_EDEAD, },
    // eWIZ1
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     4700,    16,     3,      8,    eeWIZZ,           8,    aWIZZ,         aNEWWIZZ,        256,    256,     4,    16,    ewMagic,         0,     0,      0,      0,    0,    isBOMBS,            0,              0,                0,               0,           74,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,   { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // eWIZ2
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     4460,    16,     4,     20,    eeWIZZ,           7,    aWIZZ,         aNEWWIZZ,         16,     16,     8,     8,    ewMagic,         4,     0,     50,      0,    0,    isDEFAULT,          1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // eRAQUAM
    { 0x00000004,    0x00000000,     226,     4,    2,      0,    0,    0,     7528,     8,     6,     12,    eeAQUA,          14,    aAQUA,         aAQUA,             0,      0,     4,     2,    ewFireball2,     0,     0,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spAQUA,       0,    { edCHINK,0,0,0,edIGNORE,0,0,edCHINK,0,0,0,0,0,0,0,0,0,0,0 }, WAV_GASP, WAV_GASP, },
    // eMOLDORM
    { 0x00000004,    0x00000000,      57,     1,    0,      0,    0,    0,     2800,    16,     6,      4,    eeMOLD,           8,    aNONE,         aNONE,            32,     32,     2,     2,    wNone,           1,     0,     50,      0,    0,    isNONE,          5,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // 60 eDODONGO
    { 0x00000000,    0x00000000,     149,    10,    0,      0,    0,    0,     6700,    16,     3,     16,    eeDONGO,          8,    aDONGO,        aNEWDONGO,         0,      0,     4,     2,    wNone,           4,     0,     50,     64,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_DODONGO,      -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eMANHAN
    { 0x00000004,    0x00000000,     190,     5,    0,      0,    0,    0,     6260,    16,     8,      8,    eeMANHAN,         7,    aMANHAN,       aMANHAN,           0,     16,     4,     4,    ewFireball,      2,     16,     50,      0,    0,    isDEFAULT,         16,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_VADER,        -1,            0,    { edCHINK,0,0,0,edIGNORE,0,0,edCHINK,0,0,0,0,0,0,0,0,0,0,0 }, WAV_GASP, WAV_GASP, },
    // eGLEEOK1
    { 0x00000004,    0x00000000,     220,     6,    2,    145,    4,    0,     7000,     8,     8,     20,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     4,    ewFireball,      2,     9,     89,      0,    0,    isDEFAULT,          1,              6,                0,              48,           4,    8,   40,    168,  228,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOK,     0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eGLEEOK2
    { 0x00000004,    0x00000000,     220,     6,    2,    145,    4,    0,     7000,     8,     8,     20,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     4,    ewFireball,      2,     9,     89,      0,    0,    isDEFAULT,          2,              6,                0,              48,           4,    8,   40,    168,  228,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOK,     0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eGLEEOK3
    { 0x00000004,    0x00000000,     220,     6,    2,    145,    4,    0,     7000,     8,     8,     20,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     4,    ewFireball,      2,     9,     89,      0,    0,    isDEFAULT,          3,              6,                0,              48,           4,    8,   40,    168,  228,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOK,     0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eGLEEOK4
    { 0x0000004,    0x00000000,     220,     6,    2,    145,    4,    0,     7000,     8,     8,     20,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     4,    ewFireball,      2,     9,      89,      0,    0,    isDEFAULT,          4,              6,                0,              48,           4,    8,   40,    168,  228,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOK,     0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eDIG1
    { 0x00000004,    0x00000000,     230,     4,    2,    160,    2,    0,     5580,    16,     8,     12,    eeDIG,           14,    aDIG,          aDIG,              6,      8,     8,     4,    wNone,           2,     16,     25,      0,    0,    isDEFAULT,          eDIGPUP1,       eDIGPUP2,         eDIGPUP3,        eDIGPUP4,    1,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_VADER,         spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // eDIG3
    { 0x00000004,    0x00000000,     230,     4,    2,    160,    2,    0,     5780,    16,     8,     12,    eeDIG,           14,    aDIG,          aDIG,              6,      8,     8,     4,    wNone,           2,     16,     25,      0,    0,    isDEFAULT,          eDIGPUP1,       eDIGPUP2,         eDIGPUP3,        eDIGPUP4,    0,    1,    1,      1,    0,    0,    0,    0,    0,    0,    0,       WAV_VADER,         spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // eDIGPUP1
    { 0x00000004,    0x00000000,     160,     2,    0,      0,    0,    0,     5740,    16,     2,     16,    eeDIG,           14,    aDIG,          aDIG,             12,     16,     8,     4,    wNone,           2,     16,     25,      0,    0,    isDEFAULT,          1,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,      -1,                 spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // eDIGPUP2
    { 0x00000004,    0x00000000,     160,     2,    0,      0,    0,    0,     5940,    16,     2,     16,    eeDIG,           14,    aDIG,          aDIG,             12,     16,     8,     4,    wNone,           2,     16,     25,      0,    0,    isDEFAULT,          1,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,      -1,                 spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // 70 eDIGPUP3
    { 0x00000004,    0x00000000,     160,     2,    0,      0,    0,    0,     5980,    16,     2,     16,    eeDIG,           14,    aDIG,          aDIG,             12,     16,     8,     4,    wNone,           2,     16,     25,      0,    0,    isDEFAULT,          1,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,      -1,                 spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // eDIGPUP4
    { 0x00000004,    0x00000000,     160,     2,    0,      0,    0,    0,     6020,    16,     2,     16,    eeDIG,           14,    aDIG,          aDIG,             12,     16,     8,     4,    wNone,           2,     16,     25,      0,    0,    isDEFAULT,          1,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,      -1,                 spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // eGOHMA1
    { 0x00000004,    0x00000000,     180,     6,    0,      0,    0,    0,     6920,    12,     1,      4,    eeGHOMA,          8,    aGHOMA,        aGHOMA,            0,      0,     8,     4,    ewFireball2,     0,     0,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_DODONGO,      -1,            0,    { edCHINK,edX,edX,0,edX,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK }, WAV_GASP, WAV_GASP, },
    // eGOHMA2
    { 0x00000004,    0x00000000,     180,     6,    0,      0,    0,    0,     6940,    12,     1,     12,    eeGHOMA,          7,    aGHOMA,        aGHOMA,            0,      0,     8,     4,    ewFireball2,     0,     0,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_DODONGO,      -1,            0,    { edCHINK,edX,edX,0,edX,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK }, WAV_GASP, WAV_GASP, },
    // eCENT1
    { 0x00000000,    0x00000000,     173,     2,    0,      0,    0,    0,     2680,    16,     3,      4,    eeLANM,           8,    aLANM,         aLANM,             8,      8,     8,     8,    wNone,           8,     0,    100,      0,    0,    isDEFAULT,          5,              3,                7,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eCENT2
    { 0x00000000,    0x00000000,     173,     2,    0,      0,    0,    0,     2740,    16,     3,      4,    eeLANM,           7,    aLANM,         aLANM,             4,      4,     8,     8,    wNone,           8,     0,    200,      0,    0,    isDEFAULT,          5,              2,                3,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // ePATRA1
    { 0x00000004,    0x00000000,     191,     3,    0,      0,    0,    0,     5020,    16,     2,     22,    eePATRA,          7,    aFLIP,         a4FRM8EYE,         4,      4,     8,     8,    wNone,           3,     8,     25,      0,    0,    isDEFAULT,          8,              0,               12,               0,           0,    6,    3,     40,    8,    0,    0,    0,    0,    0,    0,       WAV_VADER,        -1,            0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // ePATRA2
    { 0x00000004,    0x00000000,     191,     3,    0,      0,    0,    0,     5100,    16,     2,     22,    eePATRA,          7,    aFLIP,         a4FRM8EYE,         4,      4,     8,     8,    wNone,           3,     8,     25,      0,    0,    isDEFAULT,          8,              0,               12,               1,           0,    8,    4,     40,    8,    0,    0,    0,    0,    0,    0,       WAV_VADER,        -1,            0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eGANON
    { 0x00000004,    0x00002000,     260,    10,    2,      0,    0,    0,     8360,    16,     2,     32,    eeGANON,         14,    aGANON,        aGANON,            0,      0,    16,     4,    ewFireball,      5,     0,    100,     72,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       -1,               spGANON,       0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, WAV_GASP, WAV_GASP, },
    // eSTALFOS2
    { 0x00000000,    0x00000000,     125,     1,    0,      0,    0,    0,     3980,    16,     3,      4,    eeWALK,           8,    aFLIP,         a4FRM4DIRF,       16,     16,     2,     8,    ewSword,         4,     4,     50,    128,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // 80 eROPE2
    { 0x00000000,    0x00000001,     126,     2,    0,      0,    0,    0,     2440,    16,     1,      8,    eeWALK,           8,    aROPE,         a4FRM4DIR,        16,     16,     2,     2,    wNone,           4,     0,     50,      0,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,      0, e9tROPE, 0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eBUBBLESP
    { 0x00000008,    0x00000000,     111,     1,    0,      0,    0,    0,     1900,    16,     1,      2,    eeWALK,           8,    aFLIP,         a4FRM4DIR,         8,      8,     0,     0,    wNone,           4,     0,    100,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,e7tPERMJINX,0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eBUBBLESR
    { 0x00000008,    0x00000000,     111,     1,    0,      0,    0,    0,     1920,    16,     1,      2,    eeWALK,           7,    aFLIP,         a4FRM4DIR,         8,      8,     0,     0,    wNone,           4,     0,    100,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0, e7tUNJINX, 0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eSHOOTFBALL
    { 0x00000000,    0x00000400,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eePROJECTILE,     0,    aNONE,         aNONE,             0,      0,     0,     2,    ewFireball,      0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eITEMFAIRY
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eeFAIRY,          0,    aNONE,         aNONE,           256,    256,     0,     0,    wNone,           0,     0,     50,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eFIRE
    { 0x00000001,    0x00000000,      65,     1,    0,      0,    0,    0,     3160,    16,     2,      2,    eeFIRE,           8,    aFLIP,         a4FRM8EYE,        12,     16,     2,     2,    wNone,           0,     0,      0,      0,    0,    isNONE,             1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eCOCTO
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     3660,    16,     3,     40,    eeWALK,           9,    aOCTO,         a4FRM4DIRF,        4,      4,    20,    40,    ewMagic,        16,     1,    200,    255,    0,    isMAGIC,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eDKNUT5
    { 0x11000000,    0x00000000,     140,     5,    0,    860,    5,    0,     4280,    16,     3,     60,    eeWALK,           9,    aDWALK,        a4FRM4DIR,        16,     16,    40,    80,    ewSword,         2,     0,    150,    255,    0,    isLIFE,             e1tCONSTANT,    0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edCHINK,edIGNORE,0,edCHINK,0,0,0,0,0,0,0,edCHINK,edCHINK,edCHINK,0,0 }, 0, WAV_EDEAD, },
    // eGELTRIB
    { 0x00000001,    0x00000000,     120,     2,    0,      0,    0,    0,     1820,    16,     1,      1,    eeWALK,           9,    a2FRM,         a4FRM4DIR,         4,      8,     2,     2,    wNone,           4,    16,    100,     64,    0,    isMAGIC,            0,              e2tTRIBBLE,       eZOLTRIB,        1,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eZOLTRIB
    { 0x00000000,    0x00000000,     137,     2,    0,      0,    0,    0,     1840,    16,     1,      8,    eeWALK,           9,    a2FRM,         a4FRM4DIR,        16,     16,     4,     4,    wNone,           4,    16,     40,    144,    0,    isMAGICMONEY,       0,              e2tSPLITHIT,      eGELTRIB,        2,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // 90 eKEESETRIB
    { 0x00000001,    0x00000000,     123,     2,    0,      0,    0,    0,     1700,    16,     2,      1,    eeKEESE,          9,    a2FRMPOS,      a4FRMPOS8DIR,      0,      0,     2,     2,    wNone,           2,     8,     62,      0,    0,    isMAGIC,            0,              e2tKEESETRIB,     eVIRETRIB,       1,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eVIRETRIB
    { 0x00000000,    0x00000000,     165,     4,    0,      0,    0,    0,     1740,    16,     1,     16,    eeWALK,           9,    aVIRE,         a4FRM4DIR,        20,     20,     4,     4,    wNone,           4,     0,     50,     64,    0,    isMAGICBOMBS,       0,              e2tSPLITHIT,      eKEESETRIB,      2,           0,    0,    0,      0, e9tVIRE, 0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eDKNUT3
    { 0x11000000,    0x00000000,     140,     5,    0,    860,    5,    0,     4260,    16,     1,     32,    eeWALK,           9,    aDWALK,        a4FRM4DIR,        16,     16,    16,     4,    wNone,           3,     0,    100,    200,    0,    isMAGIC,            0,              e2tSPLIT,         eDKNUT2,         2,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edCHINK,edIGNORE,0,edCHINK,0,0,0,0,0,0,0,edCHINK,edCHINK,edCHINK,0,0 }, 0, WAV_EDEAD, },
    // eLAQUAM
    { 0x00000004,    0x00000000,     226,     4,    2,      0,    0,    0,     7520,     8,     6,     12,    eeAQUA,          14,    aAQUA,         aAQUA,             0,      0,     4,     2,    ewFireball2,     0,     0,      0,      0,    0,    isDEFAULT,          1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spAQUA,       0,    { edCHINK,0,0,0,edIGNORE,0,0,edCHINK,0,0,0,0,0,0,0,0,0,0,0 }, WAV_GASP, WAV_GASP, },
    // eMANHAN2
    { 0x00000004,    0x00000000,     190,     5,    0,      0,    0,    0,     6420,    16,    14,      8,    eeMANHAN,         8,    aMANHAN,       aMANHAN,           0,      0,     4,     4,    ewFireball,      2,     16,     50,      0,    0,    isDEFAULT,         16,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_VADER,        -1,            0,    { edCHINK,0,0,0,edIGNORE,0,0,edCHINK,0,0,0,0,0,0,0,0,0,0,0 }, WAV_GASP, WAV_GASP, },
    // eTRAP_H
    { 0x00000008,    0x00000010,     122,     1,    0,      0,    0,    0,     2080,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,        16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_V
    { 0x00000008,    0x00000020,     122,     1,    0,      0,    0,    0,     2060,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,        16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             2,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_LR
    { 0x00000008,    0x00000080,     122,     1,    0,      0,    0,    0,     2120,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,        16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             1,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_UD
    { 0x00000008,    0x00000100,     122,     1,    0,      0,    0,    0,     2100,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,        16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             2,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eFWIZ
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     4540,    16,     4,     24,    eeWIZZ,           8,    aWIZZ,         aNEWWIZZ,         16,     16,     8,     8,    ewFlame,         4,     0,     50,      0,    0,    isMAGIC,            1,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // 100 eWWIZ
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     4760,    16,     3,     28,    eeWIZZ,           7,    aWIZZ,         aNEWWIZZ,        256,    256,     4,    16,    ewWind,          0,     0,      0,      0,    0,    isMAGICBOMBS,       0,              0,                0,               0,          74,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // eCEILINGM
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eFLOORM
    { 0x00000001,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // ePATRABS
    { 0x00000004,    0x00000000,     191,     3,    0,      0,    0,    0,     6060,    16,    10,     22,    eePATRA,          7,    aFLIP,         a4FRM8EYE,         4,      4,     8,     8,    wNone,           3,     8,     25,      0,    0,    isDEFAULT,          6,              0,               12,               1,           0,    8,    4,    160,    8,    1,    0,    0,    0,    0,    0,       WAV_VADER,        -1,            0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // ePATRAL2
    { 0x00000004,    0x00000000,     191,     3,    0,      0,    0,    0,     5180,    16,    10,     44,    eePATRA,          7,    aFLIP,         a4FRM8EYE,         4,      4,     8,     8,    ewFireball,      3,     8,     25,      0,    0,    isDEFAULT,          8,              8,               18,               0,           1,    6,    3,    160,    8,    0,    0,    0,    0,    0,    0,       WAV_VADER,        -1,            0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // ePATRAL3
    { 0x00000004,    0x00000000,     191,     3,    0,      0,    0,    0,     5380,    16,    10,     44,    eePATRA,          7,    aFLIP,         a4FRM8EYE,         4,      4,     8,     8,    ewFireball,      3,     8,     25,      0,    0,    isDEFAULT,          8,              8,               18,               0,           2,    6,    3,    160,    8,    0,    0,    0,    0,    0,    0,       WAV_VADER,        -1,            0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eBAT
    { 0x00000001,    0x00000000,     123,     2,    0,      0,    0,    0,     4880,    16,     2,      8,    eeKEESE,          9,    a2FRMPOS,      a4FRMPOS8DIR,      0,      0,     6,     6,    wNone,           2,     8,    100,      0,    0,    isMAGIC,            1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eBATROBE
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     4820,    16,     3,     28,    eeWIZZ,           9,    aWIZZ,         aNEWWIZZ,        256,    256,     4,    16,    ewMagic,         0,     0,      0,      0,    0,    isMAGICBOMBS,       0,              2,                eBAT,            0,          74,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // eBATROBEKING
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      0,    eeGUY,            0,    aNONE,         aNONE,             0,      0,     0,     0,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // eGLEEOK1F
    { 0x00000004,    0x00000000,     220,     6,    2,    145,    0,    0,     7012,     8,     8,     30,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     8,    ewFlame,           2,     9,    89,      0,    0,    isDEFAULT,          1,             10,                1,              48,           4,   28,   40,    336,  396,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOKF,    0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // 110 eGLEEOK2F
    { 0x00000004,    0x00000000,     220,     6,    2,    145,    0,    0,     7012,     8,     8,     30,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     8,    ewFlame,           2,     9,    89,      0,    0,    isDEFAULT,          2,             10,                1,              48,           4,   28,   40,    336,  396,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOKF,    0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eGLEEOK3F
    { 0x00000004,    0x00000000,     220,     6,    2,    145,    0,    0,     7012,     8,     8,     30,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     8,    ewFlame,           2,     9,    89,      0,    0,    isDEFAULT,          3,             10,                1,              48,           4,   28,   40,    336,  396,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOKF,    0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eGLEEOK4F
    { 0x00000004,    0x00000000,     220,     6,    2,    145,    0,    0,     7012,     8,     8,     30,    eeGLEEOK,        14,    aGLEEOK,       aGLEEOK,           0,      0,     4,     8,    ewFlame,           2,     9,    89,      0,    0,    isDEFAULT,          4,             10,                1,              48,           4,   28,   40,    336,  396,    0,    0,    0,    0,    0,    0,       WAV_ROAR,          spGLEEOKF,    0,    { edCHINK,edX,edX,edCHINK,edX,0,edCHINK,edCHINK,0,0,0,0,edCHINK,edX,edX,edX,edX,edX,edX }, WAV_GASP, WAV_GASP, },
    // eMWIZ
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     4620,    16,     4,    192,    eeWIZZ,           9,    aWIZZ,         aNEWWIZZ,         16,     16,    32,    32,    ewMagic,         4,     0,     75,      0,    0,    isMAGIC,            1,              0,                0,               1,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,0,0,edX,edX,edX,edX,edX,0 }, 0, WAV_EDEAD, },
    // eDODONGOBS
    { 0x00000000,    0x00000000,    6760,    16,    4,      0,    0,    0,     6760,    16,     4,     16,    eeDONGO,         14,    aDONGOBS,      aDONGOBS,          0,      0,     4,     2,    wNone,           4,     0,     50,     64,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,       WAV_DODONGO,       spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // eDODONGOF
    { 0x00000000,    0x00000000,    6840,    16,    4,      0,    0,    0,     6840,    16,     4,     16,    eeDONGO,         14,    aDONGOBS,      aDONGOBS,          0,      0,     4,     2,    wNone,           4,     0,     50,     64,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,       WAV_DODONGO,       spDIG,        0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_GASP, },
    // eTRIGGER
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eeNONE,           8,    aNONE,         aNONE,             1,      1,     2,     2,    wNone,           0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eBUBBLEIT
    { 0x00000008,    0x00000001,     111,     1,    0,      0,    0,    0,     1940,    16,     1,      2,    eeWALK,           9,    aFLIP,         a4FRM4DIR,         8,      8,     0,     0,    wNone,           4,     0,    100,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,e7tTEMPJINX,e8tITEM,0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,  { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eBUBBLEIP
    { 0x00000008,    0x00000000,     111,     1,    0,      0,    0,    0,     1960,    16,     1,      2,    eeWALK,           8,    aFLIP,         a4FRM4DIR,         8,      8,     0,     0,    wNone,           4,     0,    100,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,e7tPERMJINX,e8tITEM,0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,  { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eBUBBLEIR
    { 0x00000008,    0x00000000,     111,     1,    0,      0,    0,    0,     1980,    16,     1,      2,    eeWALK,           7,    aFLIP,         a4FRM4DIR,         8,      8,     0,     0,    wNone,           4,     0,    100,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,e7tUNJINX, e8tITEM, 0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,  { edSTUNORIGNORE,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // 120 eSTALFOS3
    { 0x00000000,    0x00000000,     125,     1,    0,      0,    0,    0,     4040,    16,     3,     12,    eeWALK,           9,    aFLIP,         a4FRM4DIRF,        8,      8,     6,    24,    ewSword,         4,     4,    100,    200,    0,    isMAGIC,           e1t4SHOTS,       0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGOHMA3
    { 0x00000004,    0x00000000,     180,     6,    0,      0,    0,    0,     6960,    12,     1,     24,    eeGHOMA,          8,    aGHOMA,        aGHOMA,            0,      0,    16,     8,    ewFireball2,     0,     0,      0,      0,    0,    isDEFAULT,          1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_DODONGO,      -1,            0,    { edCHINK,edX,edX,edCHINKL4,edX,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK }, WAV_GASP, WAV_GASP, },
    // eGOHMA4
    { 0x00000004,    0x00000000,     180,     6,    0,      0,    0,    0,     6980,    12,     1,     48,    eeGHOMA,          7,    aGHOMA,        aGHOMA,            0,      0,    16,     8,    ewFlame,         0,     0,      0,      0,    0,    isDEFAULT,          2,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,       WAV_DODONGO,      -1,            0,    { edCHINK,edX,edX,edCHINKL8,edX,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK,edCHINK }, WAV_GASP, WAV_GASP, },
    // eNPCSTAND1
    { 0x00000000,    0x00000000,       0,    16,    1,      0,    0,    0,        0,    16,     1,      2,    eeGUY,            7,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCSTAND2
    { 0x00000000,    0x00000000,      20,    16,    1,      0,    0,    0,       20,    16,     1,      2,    eeGUY,            7,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCSTAND3
    { 0x00000000,    0x00000000,      40,    16,    1,      0,    0,    0,       40,    16,     1,      2,    eeGUY,            7,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCSTAND4
    { 0x00000000,    0x00000000,      60,    16,    1,      0,    0,    0,       60,    16,     1,      2,    eeGUY,            8,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCSTAND5
    { 0x00000000,    0x00000000,      80,    16,    1,      0,    0,    0,       80,    16,     1,      2,    eeGUY,            8,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCSTAND6
    { 0x00000000,    0x00000000,     100,    16,    1,      0,    0,    0,      100,    16,     1,      2,    eeGUY,            8,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCWALK1
    { 0x00000000,    0x00000000,     120,    16,    1,      0,    0,    0,      120,    16,     1,      2,    eeGUY,            7,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,     50,      0,    0,    isDEFAULT,          0,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // 130 eNPCWALK2
    { 0x00000000,    0x00000000,     140,    16,    1,      0,    0,    0,      140,    16,     1,      2,    eeGUY,            7,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,     50,      0,    0,    isDEFAULT,          0,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCWALK3
    { 0x00000000,    0x00000000,     160,    16,    1,      0,    0,    0,      160,    16,     1,      2,    eeGUY,            7,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,     50,      0,    0,    isDEFAULT,          0,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCWALK4
    { 0x00000000,    0x00000000,     180,    16,    1,      0,    0,    0,      180,    16,     1,      2,    eeGUY,            8,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,     50,      0,    0,    isDEFAULT,          0,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCWALK5
    { 0x00000000,    0x00000000,     200,    16,    1,      0,    0,    0,      200,    16,     1,      2,    eeGUY,            8,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,     50,      0,    0,    isDEFAULT,          0,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eNPCWALK6
    { 0x00000000,    0x00000000,     220,    16,    1,      0,    0,    0,      220,    16,     1,      2,    eeGUY,            8,    a2FRM4DIR,     a4FRM4DIR,        12,     12,     2,     2,    wNone,           4,     3,     50,      0,    0,    isDEFAULT,          0,              1,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eBOULDER
    { 0x00000008,    0x00000000,    3260,     4,    2,      0,    0,    0,     3260,    16,     8,      2,    eeROCK,           8,    a2FRMB,        a4FRM8DIRB,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    1,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eGORIYA3
    { 0x00000000,    0x00000000,     130,     4,    0,      0,    0,    0,     8480,    16,     3,     18,    eeWALK,         9,    aWALK,         a4FRM4DIRF,       12,     12,     8,     8,    ewBrang,         9,     9,     50,    128,    4,    isMAGICBOMBS,       e1tHOMINGBRANG, 0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eLEV3
    { 0x00000000,    0x00000000,      96,     5,    0,      0,    0,    0,     8540,    16,     3,     16,    eeLEV,            9,    aLEV,          aNEWLEV,          40,     16,     8,     4,    wNone,           8,     0,    300,      0,    0,    isMAGICBOMBS,       2,              9,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,edCHINK,0,0,0 }, 0, WAV_EDEAD, },
    // eOCTO3S
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     8600,    16,     3,      8,    eeWALK,          8,    aOCTO,         a4FRM4DIRF,       12,     12,     4,     4,    ewFlame,         4,     3,    100,     64,    3,    isMAGICBOMBS,       e1tFIREOCTO,    e2tFIREOCTO,      0,              16,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eOCTO3F
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     8660,    16,     3,      8,    eeWALK,          8,    aOCTO,         a4FRM4DIRF,       12,     12,     4,     4,    ewFlame,         4,     5,    200,     64,    3,    isMAGICBOMBS,       e1tFIREOCTO,    e2tFIREOCTO,      0,              16,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // 140 eOCTO4S
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     8720,    16,     3,     20,    eeWALK,         10,    aOCTO,         a4FRM4DIRF,        8,      8,    12,    12,    ewLitBomb,       4,     3,    100,     64,    3,    isMAGICBOMBS,       0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eOCTO4F
    { 0x00000000,    0x00000000,      92,     4,    0,      0,    0,    0,     8780,    16,     3,     20,    eeWALK,         10,    aOCTO,         a4FRM4DIRF,        8,      8,    12,    12,    ewLitBomb,       4,     5,    200,     64,    3,    isMAGICBOMBS,       0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eTRAP_8WAY
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     8840,    16,     2,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             3,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_DIAGONAL
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     8880,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             4,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_SLASH_C
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     8900,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             5,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_SLASH_LOS
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     8920,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             6,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_BACKSLASH_C
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     8940,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             7,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_BACKSLASH_LOS
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     8960,    16,     1,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             8,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_CW_C
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     8980,    16,     2,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,             9,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_CW_LOS
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     9020,    16,     2,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,            10,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // 150 eTRAP_CCW_C
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     9060,    16,     2,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,            11,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eTRAP_CCW_LOS
    { 0x00000008,    0x00000000,     122,     1,    0,      0,    0,    0,     9100,    16,     2,      2,    eeTRAP,           7,    aNONE,         a4FRM4DIR,       16,     16,     4,     4,    wNone,           0,     0,      0,      0,    0,    isNONE,            12,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eSUMMONER
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     9140,    16,     3,      8,    eeWIZZ,           9,    aWIZZ,         aNEWWIZZ,        256,    256,     4,    16,    ewMagic,         0,     0,      0,      0,    0,    isBOMBS,            0,              3,                0,               0,          74,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // eIWIZ
    { 0x00000000,    0x00000000,     169,     4,    0,      0,    0,    0,     9200,    16,     3,      8,    eeWIZZ,           9,    aWIZZ,         aNEWWIZZ,        256,    256,     4,    16,    ewMagic,         0,     0,      0,      0,    0,    isBOMBS,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edIGNORE,edIGNORE,edIGNORE,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edIGNORE,0,0 }, 0, WAV_EDEAD, },
    // eSHOOTMAGIC
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eePROJECTILE,     0,    aNONE,         aNONE,             0,      0,     0,    16,    ewMagic,         0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eSHOOTROCK
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eePROJECTILE,     0,    aNONE,         aNONE,             0,      0,     0,     2,    ewRock,          0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eSHOOTSPEAR
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eePROJECTILE,     0,    aNONE,         aNONE,             0,      0,     0,     2,    ewArrow,         0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eSHOOTSWORD
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eePROJECTILE,     0,    aNONE,         aNONE,             0,      0,     0,     8,    ewSword,         0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eSHOOTFLAME
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eePROJECTILE,     0,    aNONE,         aNONE,             0,      0,     0,     4,    ewFlame,         0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // eSHOOTFLAME2
    { 0x00000000,    0x00000000,       0,     0,    0,      0,    0,    0,        0,    16,     1,      2,    eePROJECTILE,     0,    aNONE,         aNONE,             0,      0,     0,    12,    ewFlame2,        0,     0,      0,      0,    0,    isNONE,             0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX,edX }, 0, WAV_EDEAD, },
    // 160 eBOMBCHU
    { 0x00000000,    0x00000000,     126,     2,    0,      0,    0,    0,     9260,    16,     2,      2,    eeWALK,           8,    aROPE,         a4FRM4DIR,        16,     16,     2,     2,    ewBomb,          4,     0,     50,      0,    0,    isMONEY,            0,              e2tBOMBCHU,       1,               8,           0,    0,    0,      0, e9tROPE,  0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eFGEL
    { 0x00000000,    0x00000000,     120,     2,    0,      0,    0,    0,     9300,    16,     1,      4,    eeWALK,           8,    a2FRM,         a4FRM4DIR,         4,      8,     4,     4,    ewFireTrail,     4,    16,    100,     64,    0,    isNONE,             e1tEACHTILE,    0,               0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eFZOL
    { 0x00000000,    0x00000000,     137,     2,    0,      0,    0,    0,     9320,    16,     1,      8,    eeWALK,           8,    a2FRM,         a4FRM4DIR,        16,     16,     8,     8,    ewFireTrail,     4,    16,     40,    144,    0,    isMONEY,            e1tEACHTILE,    e2tSPLITHIT,      161,             2,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eFGELTRIB
    { 0x00000000,    0x00000000,     120,     2,    0,      0,    0,    0,     9340,    16,     1,      4,    eeWALK,           8,    a2FRM,         a4FRM4DIR,         4,      8,     4,     4,    ewFireTrail,     4,    16,    100,     64,    0,    isMAGIC,            e1tEACHTILE,    e2tTRIBBLE,    eFZOLTRIB,        1,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eFZOLTRIB
    { 0x00000000,    0x00000000,     137,     2,    0,      0,    0,    0,     9360,    16,     1,      8,    eeWALK,           8,    a2FRM,         a4FRM4DIR,        16,     16,     8,     8,    ewFireTrail,     4,    16,     40,    144,    0,    isMAGICMONEY,       e1tEACHTILE,   e2tSPLITHIT,    eFGELTRIB,        2,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eTEK3
    { 0x00000000,    0x00000000,     103,     2,    0,      0,    0,    0,     9380,    16,     2,      2,    eeTEK,            8,    aTEK,          aNEWTEK,          32,     32,     2,     2,    wNone,           0,     0,    250,      0,    0,    isMAGICMONEY,      80,             16,               50,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eSPINTILE1
    { 0x00000000,    0x00000000,       0,     4,    0,      0,    0,    0,        0,     0,     0,      2,    eeSPINTILE,       8,    a4FRMNODIR,    a4FRMNODIR,       12,     12,     4,     4,    wNone,           4,     3,    200,     64,    1,    isNONE,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eSPINTILE2
    { 0x00000000,    0x00000000,   10080,     4,    0,      0,    0,    0,    10080,     0,     0,      2,    eeSPINTILE,       8,    a4FRM4DIR,     a4FRM4DIR,        12,     12,     4,     4,    wNone,           4,     3,    200,     64,    1,    isNONE,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eLYNEL3
    { 0x00000000,    0x00000000,     105,     4,    0,      0,    0,    0,     9420,    16,     3,     12,    eeWALK,           8,    aWALK,         a4FRM4DIRF,       12,     16,     8,     8,    ewSword,         6,     4,     50,    128,    3,    isMAGICBOMBS,       9,              3,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eFPEAHAT
    { 0x00000000,    0x00000000,     101,     2,    0,      0,    0,    0,     9480,    16,     6,      4,    eePEAHAT,         8,    a2FRMPOS,      a4FRMPOS8DIR,      0,      0,     2,     2,    wNone,           4,     8,     62,      0,    0,    isDEFAULT,          0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNONLY,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // 170 eMPOLSV
    { 0x00000000,    0x00000000,     134,     2,    0,   9620,    0,    0,     9600,    16,     2,     20,    eeWALK,           7,    a2FRM,         a4FRM4DIR,        16,     16,     8,     8,    wNone,           4,     10,    50,     32,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,   0, e9tPOLSVOICE, 0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,edIGNORE,edIGNORE,edCHINK,edIGNORE,0,ed1HKO,edSTUNONLY,0,0,0,0,ed1HKO,0,0,0,edCHINK,0 }, 0, WAV_EDEAD, },
    // eWPOLSV
    { 0x00000000,    0x00000000,     134,     2,    0,   9660,    0,    0,     9640,    16,     4,     20,    eeWALK,           7,    a2FRM,         a4FRM4DIR,        16,     16,     8,     8,    wNone,           4,     10,     50,     32,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,   0, e9tPOLSVOICE, 0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,edIGNORE,edIGNORE,ed1HKO,edIGNORE,0,edCHINK,edSTUNONLY,0,0,0,0,0,0,0,0,edCHINK,0 }, 0, WAV_EDEAD, },
    // eDKNUT4
    { 0x11000000,    0x00000000,     140,     5,    0,      0,    5,    0,     9720,    16,     1,     32,    eeWALK,           8,    aDWALK,        a4FRM4DIR,        16,     16,    16,     4,    wNone,           4,     0,    100,    200,    0,    isMAGIC,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { edSTUNORCHINK,0,0,edCHINK,edIGNORE,0,edCHINK,0,0,0,0,0,0,0,edCHINK,edCHINK,edCHINK,0,0 }, 0, WAV_EDEAD, },
    // eFGHINI
    { 0x00000000,    0x00000000,     109,     2,    0,      0,    0,    0,     9740,    16,     2,     18,    eeWALK,          8,    aGHINI,        a4FRMPOS4DIR,    256,    256,     4,     4,    wNone,           4,     0,     50,      0,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eMGHINI
    { 0x00000000,    0x00000000,     109,     2,    0,      0,    0,    0,     9780,    16,     2,     18,    eeWALK,          7,    aGHINI,        a4FRMPOS4DIR,    256,    256,     4,     4,    wNone,           4,     0,     50,      0,    0,    isMONEY,            0,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGRAPBUGHP
    { 0x00000001,    0x00000000,      65,     1,    0,      0,    0,    0,     9820,    16,     4,      2,    eeGUY,            7,    aFLIP,         a4FRM8EYE,        12,     16,     2,     2,    wNone,           0,     0,      0,      0,    0,    isNONE,             1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,    { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, },
    // eGRAPBUGMP
    { 0x00000001,    0x00000000,      65,     1,    0,      0,    0,    0,    10000,    16,     4,      2,    eeGUY,            8,    aFLIP,         a4FRM8EYE,        12,     16,     2,     2,    wNone,           0,     0,      0,      0,    0,    isNONE,             1,              0,                0,               0,           0,    0,    0,      0,    0,    0,    0,    0,    0,    0,    0,      -1,                -1,            0,   { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }, 0, WAV_EDEAD, }
};

item_drop_object default_item_drop_sets[isMAX]=
{
    { "None",               { 0,            0,         0,         0,           0,           0,           0,        0,      0,      0 },   {   1,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 } },
    { "Default",            { iFairyMoving, i10Rupies, i5Rupies,  i1ArrowAmmo, iHeart,      iRupy,       0,        0,      0,      0 },   {  60,   3,   3,   5,   7,  12,  20,   0,   0,   0,   0 } },
    { "Bombs",              { iFairyMoving, iClock,    i10Rupies, iRupy,       i5Rupies,    i1ArrowAmmo, iHeart,   iBombs, 0,      0 },   {  58,   2,   4,   4,  10,   4,   5,  10,  12,   0,   0 } },
    { "Rupees",             { iFairyMoving, i10Rupies, iClock,    i1ArrowAmmo, i5Rupies,    iHeart,      iRupy,    0,      0,      0 },   {  45,   3,   3,   5,   7,  15,  10,  22,   0,   0,   0 } },
    { "Life",               { iFairyMoving, iRupy,     iHeart,    0,           0,           0,           0,        0,      0,      0 },   {  13,   2,   2,   8,   0,   0,   0,   0,   0,   0,   0 } },
    { "Bombs 100%",         { iBombs,       0,         0,         0,           0,           0,           0,        0,      0,      0 },   {   0,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0 } },
    { "Super Bombs 100%",   { iSBomb,       0,         0,         0,           0,           0,           0,        0,      0,      0 },   {   0,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0 } },
    { "Magic",              { iLMagic,      iSMagic,   0,         0,           0,           0,           0,        0,      0,      0 },   {  19,   2,   4,   0,   0,   0,   0,   0,   0,   0,   0 } },
    { "Magic + Bombs",      { iFairyMoving, iLMagic,   i10Rupies, iSMagic,     iClock,      iRupy,       i5Rupies, iHeart, iBombs, 0 },   {  26,   1,   1,   1,   2,   2,   5,   2,   5,   6,   0 } },
    { "Magic + Rupees",     { iFairyMoving, iLMagic,   i10Rupies, iSMagic,     i1ArrowAmmo, iClock,      i5Rupies, iHeart, iRupy,  0 },   {  36,   3,   3,   3,   6,   3,   5,  15,  10,  22,   0 } },
    { "Magic + Life",       { iFairyMoving, i10Rupies, iLMagic,   i1ArrowAmmo, iSMagic,     iRupy,       iHeart,   0,      0,      0 },   {  10,   2,   1,   2,   2,   4,   8,  24,   0,   0,   0 } },
    { "Magic 100%",         { iLMagic,      iSMagic,   0,         0,           0,           0,           0,        0,      0,      0 },   {   0,   3,   1,   0,   0,   0,   0,   0,   0,   0,   0 } },
    { "Tall Grass Combos",  { iRupy,        iHeart,         0,         0,           0,           0,           0,        0,      0,      0 },   {   65,   20,   15,   0,   0,   0,   0,   0,   0,   0,   0 } },
};

